Subject: bug#30085: 25.2: Documentation for cua-rectangle-mark-mode

From: Stefan Kangas <[email-masked]>
Date: Sat, 19 Oct 2019 03:21:52 +0200

Boruch Baum <[email-masked]> writes:

> I had some time to look at the pacakge, and produced some notes and a
> patch file, before realizing that it would be a good idea to consult
> with you both before continuing and possibly wasting a lot of my
> volunteer time-budget.

That was in March 2018, but it seems like you unfortunately never got a
reply here.  Are you still working on this?  Could you send the patch
you wrote?

> @Eli: In many places in the code, there exist in-line documentation that
> would be appropriate as a doc-string; however, those cases are mostly
> internal functions of the form `cua--foo', so the question arose for me:
> is there emacs policy NOT to produce doc-strings for such functions.

It's better if they have a doc string even if they are internal
functions.  It could make sense to rework comments into doc strings,
but I don't know the specifics in this case.

> @Kim & @ELi: My initial notes and patch file are attached, for feedback
> if I got anything wrong, and for approval of the proposed changes:
>
> 1. The docstring issue, until I realized I should ask.
>
> 2. @Kim: At the end of the first diff block, I noted an issue about the
>   `cua--last-killed-rectangle' data structure. Could you set me right
>    about it?
>
> 3. I noticed that `M-m' was bound to `cua-copy-rectangle-as-text'
>    instead of `back-to-indentation', so I took the liberty of writing a
>    function `cua-resize-rectangle-back-to-indentation' and binding it to
>    `M-m', which is what most users would expect. If this approved, to
>    what should be bound `cua-copy-rectangle-as-text'
>
> 4. Function `cua-resize-rectangle-bot' had a bug in that it always
>    placed point at the actual (point-max) even though the rectangle
>    corner would not be there. This would occur when (point-max) was at a
>    column number smaller than the left edge of the rectangle. The patch
>    file includes the fix.
>
> 5. Two commonly used navigation functions, normally bound to `C-a' and
>    `C-e' were not remapped. (DONE)
>
> 6. The help message is remapped from `C-?' to `M-?' for the sanity of
>    people like me who use emacs-nox and can only perform a `C-?' by
>    typing `C-x @ c ?'.
>
> 7. The current keybindings are made using an old method of keystroke
>    definition that I find a bit scary. Is it OK / desirable to change
>    the method uniformly to use `kbd'?
>
> First slow steps.

Best regards,
Stefan Kangas